import 'package:libutil/communiation.dart';
import 'package:test/test.dart';

void echoIsolate(CrossCommunicationChannel channel) async {
  while (true) {
    channel.send(await channel.next());
  }
}

void sendAndReceive(CrossCommunicationIsolate isolate, message) async {
  isolate.send(message);
  dynamic echo = await isolate.next();
  expect(message, equals(echo));
}

void main() async {
  test('Communication', () async {
    CrossCommunicationIsolate isolate = CrossCommunicationIsolate();
    await isolate.start(echoIsolate);

    await sendAndReceive(isolate, 'a');
    await sendAndReceive(isolate, 'b');
    await sendAndReceive(isolate, 10);
    await sendAndReceive(isolate, 'd');
  });
}
