import 'dart:math';

import 'package:libutil/sorted.dart';
import 'package:test/test.dart';

void main() {
  test('Sorted list should always be sorted', () {
    SortedList<int> list = SortedList();
    Random random = Random();

    for (int i = 0; i < 100; i++) {
      list.add(random.nextInt(200));
    }

    int last = -1;
    for (int current in list) {
      if (current < last) fail('List is not sorted');
      last = current;
    }
  });

  test('Binary search', () {
    SortedList<int> list = SortedList();
    list.add(10);
    list.add(2);
    list.add(7);
    list.add(5);
    list.add(32);
    list.add(1);
    list.add(76);

    Comparator mockComparator = (a, b) => a.compareTo(b);

    expect(list.binarySearch(7), equals(3));
    expect(list.binarySearch(7, comparator: mockComparator), equals(3));
  });
}
